﻿Imports System.Web
Imports System.Web.Services
Imports System.Data.OleDb

Public Class ImageHandler
    Implements System.Web.IHttpHandler

    Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim adap As New OleDbDataAdapter("Select * from Categories", New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\C1NWind.mdb;Persist Security Info=True"))
        Dim ds As New DataSet()
        adap.Fill(ds)
        Dim dt As DataTable = ds.Tables(0)
        Dim request As HttpRequest = context.Request
        If Not String.IsNullOrEmpty(request.QueryString("id")) Then
            Dim rindex As Integer = Convert.ToInt32(request.QueryString("id"))
            Dim picData As Byte() = DirectCast(dt.Rows(rindex)(3), Byte())
            If picData IsNot Nothing Then
                ' is this is an embedded object?
                Dim bmData As Integer = If((picData(0) = &H15 AndAlso picData(1) = &H1C), 78, 0)
                ' load the picture
                Dim b As System.Drawing.Image = Nothing
                Try
                    Dim ms As New System.IO.MemoryStream(picData, bmData, picData.Length - bmData)
                    b = System.Drawing.Image.FromStream(ms)
                    Dim bitMap As New System.Drawing.Bitmap(b, b.Width, b.Height)
                    'changing content type of handler page
                    context.Response.ContentType = "image/jpeg"
                    bitMap.Save(context.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)
                    bitMap.Dispose()
                Catch
                End Try
            End If
        End If
    End Sub

    ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return False
        End Get
    End Property
End Class